#include <windows.h>
#include <windowsx.h>
#include <wingdi.h>
#include <winuser.h>
#include <Commctrl.h>

#include <CSO.h>

#include "resource.h"
#include "localdata.h"

#define		__DBG_ACTION__

#ifdef		UNDER_CE
#include <Sipapi.h>	
#endif

TCHAR szAppName[] = TEXT("CSO_SAMPLE");
TCHAR szTitle[]   = TEXT("Cso_Sample");

HINSTANCE 		hInst;				//current instance
HWND            hWnd;				//Main window handle

static	INT		ApStat;
#define		DEF_AP_STAT_FULL	0
#define		DEF_AP_STAT_HALF	1

#ifndef		UNDER_CE
#define			DEF_WINDOW_MAX_WIDTH	(240+8)
#define			DEF_WINDOW_MAX_HEIGHT	(320+48)
#else
#define			DEF_WINDOW_MAX_WIDTH	CW_USEDEFAULT
#define			DEF_WINDOW_MAX_HEIGHT	CW_USEDEFAULT
#endif

BOOL InitApplication (HINSTANCE hInstance);
BOOL InitInstance ( HINSTANCE hInstance, int nCmdShow );
LRESULT CALLBACK WndProc ( HWND hWnd, UINT message, WPARAM wParam , LPARAM lParam );

INT		DO_Create_ButtonFirst(HWND hWnd);

LRESULT CALLBACK FileDlg_ACT1(HWND hDlg, UINT message, WPARAM uParam, LPARAM lParam);
LRESULT CALLBACK FileDlg_ACT2(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

#ifndef			UNDER_CE
int APIENTRY WinMain (	HINSTANCE	hInstance, 
						HINSTANCE	hPrevInstance, 
						LPSTR 		lpCmdLine, 
						int			nCmdShow )
#else			/* UNDER_CE */
int WINAPI WinMain (	HINSTANCE	hInstance, 
						HINSTANCE	hPrevInstance, 
						LPTSTR 		lpCmdLine, 
						int			nCmdShow )
#endif			/* UNDER_CE */
{
	MSG msg;
	HANDLE hAccelTable;

	HWND	hWnd_Chk;

	hWnd_Chk = FindWindow(szAppName, NULL);
	if(hWnd_Chk){
		SetForegroundWindow((HWND)((ULONG)hWnd_Chk | 0x00000001));
		InvalidateRect(hWnd, NULL, TRUE);
		return (FALSE);
	}

	if (!hPrevInstance) {		// Other instances of app running?
			if (!InitApplication(hInstance)) { // Initialize shared things
			return (FALSE);		// Exits if unable to initialize
		}
	}

	/* Perform initializations that apply to a specific instance */
	if (!InitInstance(hInstance, nCmdShow)) {
		return (FALSE);
	}

	hAccelTable = LoadAccelerators (hInstance, szAppName);

	/* Acquire and dispatch messages until a WM_QUIT message is received. */
	while (GetMessage(&msg,	// message structure
	   NULL,				// handle of window receiving the message
	   0,					// lowest message to examine
	   0))					// highest message to examine
	{
		if (!TranslateAccelerator (msg.hwnd, hAccelTable, &msg)) {
			TranslateMessage(&msg);	// Translates virtual key codes
			DispatchMessage(&msg);	// Dispatches message to window
		}
	}

	return (msg.wParam);	// Returns the value from PostQuitMessage

	lpCmdLine;				// This will prevent 'unused formal parameter' warnings
}


BOOL InitApplication ( HINSTANCE hInstance )
{
	WNDCLASS  wc;

	// Fill in window class structure with parameters that describe the
	// main window.
#ifndef		UNDER_CE
	wc.style         = CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;// Class style(s).
#else		/* UNDER_CE */
	wc.style         = 0;
#endif		/* UNDER_CE */

	wc.lpfnWndProc   = (WNDPROC)WndProc;       // Window Procedure
	wc.cbClsExtra    = 0;                      // No per-class extra data.
	wc.cbWndExtra    = sizeof(long);           // No per-window extra data.
	wc.hInstance     = hInstance;              // Owner of this class
	wc.hIcon         = LoadIcon (hInstance, szAppName); // Icon name from .RC

	wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);// Default color
	wc.lpszClassName = szAppName;              // Name to register as

#ifndef		UNDER_CE
	wc.hCursor       = LoadCursor(NULL, IDC_ARROW);// Cursor
	wc.lpszMenuName  = szAppName;
#else		/* UNDER_CE */
	wc.hCursor       = NULL;
	wc.lpszMenuName  = NULL;
#endif		/* UNDER_CE */

	// Register the window class and return success/failure code.
	return (RegisterClass(&wc));
}


BOOL InitInstance ( HINSTANCE hInstance, int nCmdShow )
{

	hInst = hInstance; // Store instance handle in our global variable

	// Create a main window for this application instance.
#ifndef			UNDER_CE
	hWnd = CreateWindow(
		szAppName,	     // See RegisterClass() call.
		szTitle,	     // Text for window title bar.
		WS_OVERLAPPEDWINDOW,// Window style.
		CW_USEDEFAULT, 0, DEF_WINDOW_MAX_WIDTH,DEF_WINDOW_MAX_HEIGHT,
		NULL,		     // Overlapped windows have no parent.
		NULL,		     // Use the window class menu.
		hInstance,	     // This instance owns this window.
		NULL		     // We don't use any data in our WM_CREATE
	);
#else			/* UNDER_CE */
	hWnd = CreateWindow(
		szAppName, 		 // See RegisterClass() call.
		szTitle,	     // Text for window title bar.
		WS_VISIBLE,							// window style.
		CW_USEDEFAULT, 0, DEF_WINDOW_MAX_WIDTH,DEF_WINDOW_MAX_HEIGHT,
		NULL,		     // Overlapped windows have no parent.
		NULL,		     // Use the window class menu.
		hInstance,	     // This instance owns this window.
		NULL		     // We don't use any data in our WM_CREATE
	);
#endif			/* UNDER_CE */

	if (!hWnd) {
		return (FALSE);
	}

	ShowWindow(hWnd, nCmdShow); // Show the window
	UpdateWindow(hWnd);         // Sends WM_PAINT message

	return (TRUE);              // We succeeded...
}

//----------------------------------------------------------------------

static	HMENU	hMenu;
static	HMENU	menu_end_chk;
static	HMENU	menu_sendto;
static	HMENU	menu_color;

static	HWND		hWndCSOBar 	= NULL;
static	HWND		hWndBtn 	= NULL;
static	HWND		hWndCombo 	= NULL;

const	COLORREF	BackColor[] = {
	RGB(255,255,255),	// WHITE
	RGB(  0,  0,  0),	// BLACK
	RGB(255,  0,  0),	// RED
	RGB(  0,  0,255),	// BLUE
	RGB(255,255,  0),	// YELLOW
	RGB(  0,255,  0),	// GREEN
	RGB(255,128,  0),	// ORENGE
	RGB(255,  0,255)	// FUCHSIA
};


INT	DO_Create_ButtonFirst(HWND hWnd)
{
	CSOBAR_BUTTONINFO	*lpCsoBar_ButtonInfo;
	BOOL				ret_ans = FALSE;
	RECT				rect;
	HWND				hWndRadioButton;

#ifndef		UNDER_CE
	DWORD 				exStyle_Change;
#endif

	hWndCSOBar = CSOBar_Create(hInst, hWnd, DEF_CSOBAR_ID, ApCsoBar_BaseInfo);
	if(hWndCSOBar == NULL){
#ifdef		__DBG_ACTION__
		MessageBox(hWnd, TEXT("Create hWndCSOBar fail"),szAppName,
					MB_ICONERROR | MB_OK);
#endif
		DestroyWindow(hWnd);
		return (0);
	}

	ret_ans = CSOBar_AddAdornments(hWndCSOBar, hInst, 1, (CSOBAR_ADORNMENT_HELP), 0);
	ret_ans = CSOBar_AddAdornments(hWndCSOBar, hInst, 3, (CSOBAR_ADORNMENT_CLOSE), 0);

	lpCsoBar_ButtonInfo = (CSOBAR_BUTTONINFO *)LocalAlloc(LMEM_FIXED ,
								(APCSOBAR_BUTTONINFO_NUM * sizeof(CSOBAR_BUTTONINFO)) );
	if(lpCsoBar_ButtonInfo == NULL){
#ifdef		__DBG_ACTION__
		MessageBox(hWnd, TEXT("Memory Alloc fail"),szAppName,
					MB_ICONERROR | MB_OK);
#endif
		DestroyWindow(hWnd);
		return (0);
	}

	memcpy(&lpCsoBar_ButtonInfo[0], &ApCsoBar_ButtonInfo[0], 
								(APCSOBAR_BUTTONINFO_NUM * sizeof(CSOBAR_BUTTONINFO)) );
	hMenu = LoadMenu(hInst, MAKEINTRESOURCE(IDR_MENU1));
	menu_end_chk	= GetSubMenu(hMenu, 0);
	menu_sendto		= GetSubMenu(hMenu, 1);
	lpCsoBar_ButtonInfo[1].SubMenu	= menu_sendto;
	lpCsoBar_ButtonInfo[3].SubMenu	= menu_end_chk;
	lpCsoBar_ButtonInfo[9].reshInst = hInst;
	lpCsoBar_ButtonInfo[10].reshInst = hInst;
	lpCsoBar_ButtonInfo[11].reshInst = hInst;

	GetClientRect(hWndCSOBar, &rect);
	CSOBar_GetButtonArea(hWndCSOBar,&lpCsoBar_ButtonInfo[12]);
	lpCsoBar_ButtonInfo[12].x		= rect.right - lpCsoBar_ButtonInfo[12].width - CSOBar_GetAdornmentsWidth(hWndCSOBar,3);
	lpCsoBar_ButtonInfo[12].y		= ((CSOBar_Height(hWndCSOBar) / 3) * 2) + 2;

	ret_ans = CSOBar_AddButtons(hWndCSOBar, hInst, APCSOBAR_BUTTONINFO_NUM, &lpCsoBar_ButtonInfo[0]);

	if(ret_ans == FALSE){
		LocalFree(lpCsoBar_ButtonInfo);
#ifdef		__DBG_ACTION__
		MessageBox(hWnd, TEXT("CSOBar_AddButtons fail"),szAppName,
					MB_ICONERROR | MB_OK);
#endif
		DestroyWindow(hWnd);
		return (0);
	}

	hWndRadioButton = CSOBar_GetButtonItem(hWndCSOBar, TRUE, ID_M_AP_BUTTON_A, 2);
	SendMessage(hWndRadioButton, BM_SETCHECK, 1, 0);

	LocalFree(lpCsoBar_ButtonInfo);

	{
		hWndCombo	= CSOBar_InsertComboBox(hWndCSOBar, hInst, ID_M_AP_SCOBUTTON_ID002,
												CBS_DROPDOWNLIST,
												TRUE,ID_M_AP_BUTTON_ID009, 3, 100,80);
		if(hWndCombo == NULL){
#ifdef		__DBG_ACTION__
			MessageBox(hWnd, TEXT("CSOBar_InsertComboBox fail"),szAppName,
						MB_ICONERROR | MB_OK);
#endif
		}

		ComboBox_AddString(hWndCombo, TEXT("No.1"));
		ComboBox_AddString(hWndCombo, TEXT("No.2"));
		ComboBox_AddString(hWndCombo, TEXT("No.3"));
		ComboBox_SetCurSel(hWndCombo, 0 );
	}

#ifndef		UNDER_CE
	exStyle_Change = GetWindowLong(hWndCSOBar, GWL_STYLE);
	exStyle_Change &= ~WS_CLIPCHILDREN;
	SetWindowLong(hWndCSOBar, GWL_STYLE, exStyle_Change);
#endif

	{
		RECT	rect;
		#define		DEF_MYBUTTON_WIDTH		80
		#define		DEF_MYBUTTON_HEIGHT		40
		#define		DEF_MYBUTTON_SPEC_SEP	2

		const	CSO_EXSTYLE		csostyle = {0, RGB(128,0,0), RGB(0,128,0),RGB(0,0,128), TRUE, TRUE};

		GetClientRect(hWnd, &rect);

		InitCSOButton(hInst);
		hWndBtn = CreateWindow(TEXT("CSOButton"), TEXT("BackColor\nChange"),
						WS_CHILD | BS_CENTER | BS_TOP | WS_VISIBLE | BS_MULTILINE,
						(rect.right - DEF_MYBUTTON_WIDTH - DEF_MYBUTTON_SPEC_SEP),
						(rect.bottom - DEF_MYBUTTON_HEIGHT - DEF_MYBUTTON_SPEC_SEP),
						DEF_MYBUTTON_WIDTH, DEF_MYBUTTON_HEIGHT,
						hWnd,
						(HMENU)ID_M_AP_SCOBUTTON_ID001,
						hInst, NULL);

		menu_color		= GetSubMenu(hMenu, 2);
		SendMessage(hWndBtn,CSO_BM_SETFOCUSMODE, FALSE,0);
		SendMessage(hWndBtn,CSO_BM_SETMENU,      (WPARAM)menu_color, POPUPMENU_UP);
		SendMessage(hWndBtn,CSO_BM_SETEXSTYLE,   (WPARAM)0, (LPARAM)&csostyle);
	}

	return(0);
}


LRESULT CALLBACK WndProc ( HWND hWnd, UINT message, WPARAM wParam , LPARAM lParam )
{
	static	INT		Bk_Color = 0;
	RECT	rect;
	TCHAR	szBuffer[128];

	switch(message){
		case WM_CREATE:
			InitCommonControls();

			Bk_Color = 0;

			hMenu 			= NULL;
			menu_end_chk	= NULL;
			menu_sendto		= NULL;
			menu_color		= NULL;

			hWndCSOBar		= NULL;
			hWndBtn 		= NULL;
			hWndCombo		= NULL;

			ApStat = DEF_AP_STAT_FULL;

			SendMessage(hWnd, WM_COMMAND, ID_M_AP_CREATE_BUTTON_FIRST, 0);
			CheckMenuItem(menu_color, ID_M_AP_MENU_ID001, MF_BYCOMMAND | MFS_CHECKED );
			break;

		case WM_DESTROY:
			if(menu_end_chk != NULL){
				DestroyMenu(menu_end_chk);
				menu_end_chk = NULL;
			}
			if(menu_sendto != NULL){
				DestroyMenu(menu_sendto);
				menu_sendto = NULL;
			}
			if(menu_color != NULL){
				DestroyMenu(menu_color);
				menu_color = NULL;
			}
			if(hMenu != NULL){
				DestroyMenu(hMenu);
				hMenu = NULL;
			}

			CSOBar_Destroy(hWndCSOBar);

			if(hWndBtn != NULL){
				DestroyWindow(hWndBtn);
				hWndBtn = NULL;
			}

			PostQuitMessage(0);
			break;

		case WM_PAINT:
			{
				PAINTSTRUCT	ps;
				HDC	hdc;
				hdc = BeginPaint(hWnd,&ps);
				{
					HBRUSH	hBrush;
					HANDLE	holdSrc;

					hBrush   = CreateSolidBrush(BackColor[Bk_Color]);
					holdSrc  = SelectObject(hdc, hBrush);
					GetClientRect(hWnd, &rect);
					Rectangle(hdc, rect.left, rect.top,
									rect.right, rect.bottom);
					SelectObject(hdc, holdSrc);
					DeleteObject(hBrush);
				}
				EndPaint(hWnd,&ps);
			}
			break;

		case WM_NOTIFY:
			{
			    LPNMHDR pNotifyHeader;
				pNotifyHeader = (LPNMHDR)lParam;
				if(pNotifyHeader->code == CBN_DROPDOWN) {
						MessageBox(hWnd , TEXT("[TBN_DROPDOWN] was Selected."), szAppName, 
							MB_ICONINFORMATION | MB_OK);
				}
			}
			break;

		case WM_COMMAND:
			switch(LOWORD(wParam)){
				case	CBN_DROPDOWN:
					{
						MessageBox(hWnd , TEXT("[CBN_DROPDOWN] was Selected."), szAppName, 
							MB_ICONINFORMATION | MB_OK);
					}
					break;
				case	CSOBAR_ADORNMENTID_HELP:
					{
						MessageBox(hWnd , TEXT("[HELP] was Selected."), szAppName, 
							MB_ICONINFORMATION | MB_OK);
					}
					break;
				case	CSOBAR_ADORNMENTID_OK:
					{
						MessageBox(hWnd , TEXT("[OK] was Selected."), szAppName, 
							MB_ICONINFORMATION | MB_OK);
					}
					break;
				case	CSOBAR_ADORNMENTID_MENU:
					{
						MessageBox(hWnd , TEXT("[MENU] was Selected."), szAppName, 
							MB_ICONINFORMATION | MB_OK);
					}
					break;

				case	ID_M_AP_MENU_ID001:
				case	ID_M_AP_MENU_ID002:
				case	ID_M_AP_MENU_ID003:
				case	ID_M_AP_MENU_ID004:
				case	ID_M_AP_MENU_ID005:
				case	ID_M_AP_MENU_ID006:
				case	ID_M_AP_MENU_ID007:
				case	ID_M_AP_MENU_ID008:
					{
						CheckMenuItem(menu_color, (Bk_Color + ID_M_AP_MENU_ID001), MF_BYCOMMAND | MF_UNCHECKED );
						CheckMenuItem(menu_color, LOWORD(wParam), MF_BYCOMMAND | MFS_CHECKED );

						Bk_Color = LOWORD(wParam) - ID_M_AP_MENU_ID001;
						InvalidateRect(hWnd, NULL, TRUE);
					}
					break;

				case	CSOBAR_ADORNMENTID_CLOSE:
				case	ID_M_AP_END:
					DestroyWindow(hWnd);
					break;

				case	ID_M_AP_CREATE_BUTTON_FIRST:
					{
						DO_Create_ButtonFirst(hWnd);
					}
					break;

				case	ID_M_AP_BUTTON_ID003:
					{
						GetClientRect(hWnd, &rect);
						if(ApStat == DEF_AP_STAT_FULL){
							rect.bottom = (CSOBar_Height(hWndCSOBar) / 3);
							ApStat = DEF_AP_STAT_HALF;
						}
						else{
							rect.bottom = (CSOBar_Height(hWndCSOBar) * 3);
							ApStat = DEF_AP_STAT_FULL;
						}
						SetWindowPos(hWndCSOBar, NULL, rect.left, rect.top,
										(rect.right - rect.left), (rect.bottom - rect.top),
										SWP_NOZORDER );
					}
					break;

				case	ID_M_AP_MENU_ID010:
					{
						int		get = 0;
						get = CSOBar_Height(hWndCSOBar);
						wsprintf(szBuffer, TEXT("CSOBar_Height is     %d"),get);
						MessageBox( hWnd, szBuffer, TEXT("Dbg"),MB_OK);
					}
					break;

				case	ID_M_AP_BUTTON_ID007:
					{
						DialogBox(	hInst,
									MAKEINTRESOURCE(IDD_DIALOG1),
									hWnd,
									(DLGPROC)FileDlg_ACT1);
					}
					break;

				case	ID_M_AP_BUTTON_ID008:
					{
						DialogBox(	hInst,
									MAKEINTRESOURCE(IDD_DIALOG2),
									hWnd,
									(DLGPROC)FileDlg_ACT2);
					}
					break;

				case	ID_M_AP_BUTTON_A:
					{
					MessageBox(hWnd , TEXT("ID_M_AP_BUTTON_A"), szAppName, MB_ICONINFORMATION | MB_OK);
					}
					break;

				case	ID_M_AP_BUTTON_B:
					{
					MessageBox(hWnd , TEXT("ID_M_AP_BUTTON_B"), szAppName, MB_ICONINFORMATION | MB_OK);
					}
					break;

				case	ID_M_AP_BUTTON_C:
					{
					MessageBox(hWnd , TEXT("ID_M_AP_BUTTON_C"), szAppName, MB_ICONINFORMATION | MB_OK);
					}
					break;
			}
			break;

		default:
			return DefWindowProc(hWnd,message,wParam,lParam);
	}
	return (0);
}


LRESULT CALLBACK FileDlg_ACT1(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{

static	HWND	hWndDlgCSOBar 	= NULL;
#define		DEF_CSOBUTTON_NUM			9
static	HWND	hWndDlgBtn[DEF_CSOBUTTON_NUM];
static	HWND	edit_wind 		= NULL;
int		i;
RECT	rect;

#define		DEF_MYDLGBUTTON_WIDTH		40
#define		DEF_MYDLGBUTTON_HEIGHT		25

#define		DEF_MYDLGBUTTON_START_X		40
#define		DEF_MYDLGBUTTON_START_Y		100
#define		DEF_MYDLGBUTTON_STEP_X		20
#define		DEF_MYDLGBUTTON_STEP_Y		40

	switch(message){
		case WM_INITDIALOG:
			{
				GetWindowRect(GetWindow (hDlg, GW_OWNER), &rect);
				SetWindowPos(hDlg, NULL, rect.left, rect.top,
								(rect.right - rect.left), (rect.bottom - rect.top), SWP_NOZORDER);
			}
			{
				CSOBAR_BUTTONINFO	*lpCsoBar_ButtonInfo;

				GetClientRect(hDlg, &rect);
				hWndDlgCSOBar = CSOBar_Create(hInst, hDlg, DEF_CSODLGBAR_ID, ApCsoBar_DlgBaseInfo);
				lpCsoBar_ButtonInfo = (CSOBAR_BUTTONINFO *)LocalAlloc(LMEM_FIXED ,sizeof(CSOBAR_BUTTONINFO));
				memcpy(&lpCsoBar_ButtonInfo[0], &ApCsoBar_DlgButtonInfo, sizeof(CSOBAR_BUTTONINFO));
				lpCsoBar_ButtonInfo->FaceText = (TCHAR *)szKey_END;
				lpCsoBar_ButtonInfo->y		= 0;
				lpCsoBar_ButtonInfo->width	= GetDrawWidth(hDlg, lpCsoBar_ButtonInfo->FaceText) + 8;
				lpCsoBar_ButtonInfo->height	= CSOBar_Height(hWndDlgCSOBar);
				lpCsoBar_ButtonInfo->x		= rect.right - lpCsoBar_ButtonInfo->width;

				CSOBar_AddButtons(hWndDlgCSOBar, hInst, 1, &lpCsoBar_ButtonInfo[0]);
				LocalFree(lpCsoBar_ButtonInfo);
			}
			{
				int		xx;
				int		yy;

				xx = DEF_MYDLGBUTTON_START_X;
				yy = DEF_MYDLGBUTTON_START_Y;
				for(i = 0; i < DEF_CSOBUTTON_NUM; i++){
					hWndDlgBtn[i] = CreateWindow(TEXT("CSOButton"), BtCreInfo[i].szKeyMoji,
									WS_CHILD | BS_CENTER | BS_TOP | WS_VISIBLE,
									xx, yy,
									DEF_MYDLGBUTTON_WIDTH, DEF_MYDLGBUTTON_HEIGHT,
									hDlg,
									(HMENU)BtCreInfo[i].res_id,
									hInst, NULL);
					SendMessage(hWndDlgBtn[i],CSO_BM_SETFOCUSMODE, FALSE,0);
					xx += (DEF_MYDLGBUTTON_STEP_X + DEF_MYDLGBUTTON_WIDTH);
					if( (i == 2) || (i == 5) ){
						xx  = DEF_MYDLGBUTTON_START_X;
						yy += DEF_MYDLGBUTTON_STEP_Y;
					}
				}
				{
					edit_wind = CreateWindow(TEXT("EDIT"), NULL, 
												(WS_CHILD | WS_VISIBLE | ES_LEFT | ES_NOHIDESEL ),
												60, 50, 60, 20,
												hDlg, NULL,
												hInst, NULL);
				}
			}
			return TRUE;

#ifdef		UNDER_CE
		case WM_SETTINGCHANGE:
			if(wParam == SPI_SETSIPINFO){
				;
			}
			break;
#endif		/* UNDER_CE */
		/*---------------------------------------------------------------------------------------*/
		case WM_COMMAND:
			switch (LOWORD(wParam)){
				case ID_M_AP_END:
					EndDialog(hDlg, TRUE);
					return TRUE;
				case ID_M_AP_BUTTON_ID001:
					SendMessage(edit_wind, WM_CHAR, TEXT('1'), 0);
					return TRUE;
				case ID_M_AP_BUTTON_ID002:
					SendMessage(edit_wind, WM_CHAR, TEXT('2'), 0);
					return TRUE;
				case ID_M_AP_BUTTON_ID003:
					SendMessage(edit_wind, WM_CHAR, TEXT('3'), 0);
					return TRUE;
				case ID_M_AP_BUTTON_ID004:
					SendMessage(edit_wind, WM_CHAR, TEXT('4'), 0);
					return TRUE;
				case ID_M_AP_BUTTON_ID005:
					SendMessage(edit_wind, WM_CHAR, TEXT('5'), 0);
					return TRUE;
				case ID_M_AP_BUTTON_ID006:
					SendMessage(edit_wind, WM_CHAR, TEXT('6'), 0);
					return TRUE;
				case ID_M_AP_BUTTON_ID007:
					SendMessage(edit_wind, WM_CHAR, TEXT('7'), 0);
					return TRUE;
				case ID_M_AP_BUTTON_ID008:
					SendMessage(edit_wind, WM_CHAR, TEXT('8'), 0);
					return TRUE;
				case ID_M_AP_BUTTON_ID009:
					SendMessage(edit_wind, WM_CHAR, TEXT('9'), 0);
					return TRUE;
			}
			break;
		case WM_DESTROY:
			{
				CSOBar_Destroy(hWndDlgCSOBar);
				for(i = 0; i < DEF_CSOBUTTON_NUM; i++){
					DestroyWindow(hWndDlgBtn[i]);
				}
				DestroyWindow(edit_wind);
			}
			EndDialog(hDlg, wParam);
			return TRUE;
	}

	return FALSE;
}


LRESULT CALLBACK FileDlg_ACT2(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
const	CSO_EXSTYLE		csodlgstyle = {0, RGB(0,0,192), RGB(0,192,0),RGB(192,0,0), TRUE, TRUE};

static	HMENU	hMenuDlg;
static	HMENU	menu_colorDlg;
HWND	hCsoButton;

	switch(message){
		case WM_INITDIALOG:
			{
				hCsoButton	= GetDlgItem(hDlg, IDOK);

				SetWindowLong(hCsoButton, GWL_STYLE, (WS_CHILD | BS_CENTER | BS_TOP | WS_VISIBLE));

				SendMessage(hCsoButton,CSO_BM_SETFOCUSMODE, FALSE,0);

				SendMessage(hCsoButton,CSO_BM_SETEXSTYLE,   (WPARAM)0, (LPARAM)&csodlgstyle);

				hMenuDlg		= LoadMenu(hInst, MAKEINTRESOURCE(IDR_MENU2));
				menu_colorDlg	= GetSubMenu(hMenuDlg, 0);
				SendMessage(hCsoButton,CSO_BM_SETMENU, (WPARAM)menu_colorDlg, POPUPMENU_DOWN);
			}
			return TRUE;

		case WM_COMMAND:
			switch (LOWORD(wParam)){
				case	ID_M_AP_MENU_ID001:
				case	ID_M_AP_MENU_ID002:
				case	ID_M_AP_MENU_ID003:
					{
						CSO_EXSTYLE		csodlgstyle_set;
						COLORREF		rgb_tmp;

						hCsoButton	= GetDlgItem(hDlg, IDOK);

						memcpy(&csodlgstyle_set, &csodlgstyle, sizeof(CSO_EXSTYLE) );
						switch (LOWORD(wParam)){
							case	ID_M_AP_MENU_ID001:
								rgb_tmp	= csodlgstyle_set.FaceColor;
								csodlgstyle_set.FaceColor = csodlgstyle_set.TextColor;
								csodlgstyle_set.TextColor = csodlgstyle_set.TransparentColor;
								csodlgstyle_set.TransparentColor = rgb_tmp;
								break;
							case	ID_M_AP_MENU_ID002:
								rgb_tmp	= csodlgstyle_set.TextColor;
								csodlgstyle_set.TextColor = csodlgstyle_set.FaceColor;
								csodlgstyle_set.FaceColor = csodlgstyle_set.TransparentColor;
								csodlgstyle_set.TransparentColor = rgb_tmp;
								break;
							case	ID_M_AP_MENU_ID003:
								//default
								break;
						}
						SendMessage(hCsoButton,CSO_BM_SETEXSTYLE,   (WPARAM)0, (LPARAM)&csodlgstyle_set);
					}
					break;
				case	IDCLOSE:
					EndDialog(hDlg, TRUE);
					break;
			}
			break;
		case WM_DESTROY:
			DestroyMenu(menu_colorDlg);
			DestroyMenu(hMenuDlg);

			EndDialog(hDlg, wParam);
			return TRUE;
	}

	return FALSE;
}

