// casio.cpp : Entry point
//

#include "stdafx.h"
#include "casio.h"
#include <tchar.h>
#include <commctrl.h>
#include <commdlg.h>
#include <CS.h>
#include <CSO.h>
#include <CVect.h>
#ifdef	_WIN32_WCE
#include <COShellAPI.h>
#include <GetDisk.h>
#endif

#define MAX_LOADSTRING				100

// Global variable :
TCHAR		szTitle[MAX_LOADSTRING];			// Title bar text
TCHAR		szWindowClass[MAX_LOADSTRING];		// Title bar text
HINSTANCE	hInst;								// Now Instance

void FilenameCutFileName(TCHAR *fileName)
{
	TCHAR *ptr = fileName + _tcslen(fileName);
	while(1){
		ptr--;
		if ((*ptr == _T('\\')) || (*ptr == _T('/'))){
			*(++ptr) = _T('\0');
			break;
		}
		else if ((*ptr == _T('\0')) || (ptr == fileName)){
			break;
		}
	}

	return;
}


HWND casioCSOBar(HWND hWnd, HINSTANCE hInstance)
{
	CSOBAR_BASEINFO		baseInfo = {
		(-1),										// x
		(-1),										// y
		(-1),										// width
		(-1),										// height
		1,											// line
		CSOBAR_DEFAULT_BACKCOLOR,					// backColor
		CSOBAR_DEFAULT_CODECOLOR,					// titleColor
		NULL,										// titleText
		NULL,										// titleBmpResId
		NULL,										// titleBmpResIns
	};

	CSOBAR_BUTTONINFO	buttonInfo[] = {
		ID_LEFT_ARROW,								// idCommand
		CSOBAR_BUTTON_NORM,							// fsStyle
		CSO_BUTTON_DISP,							// fsState
		(-1),										// iBitmap
		NULL,										// reshInst
		NULL,										// FaceText
		NULL,										// SubMenu
		0,											// codePos
		1,											// linePos
		(-1),										// x
		(-1),										// y
		(-1),										// width
		(-1),										// height
		{											// btnExStyle
			CSO_ID_BACK,							//   BtnID
			CLR_INVALID,							//   FaceColor
			CLR_INVALID,							//   TextColor
			CLR_INVALID,							//   TransparentColor
			FALSE,									//   Bold
			FALSE,									//   Italic
		},
	};

	HWND hWndBar = CSOBar_Create(hInstance, hWnd, 1, baseInfo);
	if(hWndBar == NULL){
		DestroyWindow(hWndBar);
		return(NULL);
	}

	if ((CSOBar_AddButtons(hWndBar, hInstance, 1, buttonInfo) == FALSE) ||
	(CSOBar_AddAdornments(hWndBar, hInstance, 1, CSOBAR_ADORNMENT_CLOSE | CSOBAR_ADORNMENT_HELP, 0) == FALSE)){
		CSOBar_Destroy(hWndBar);
		DestroyWindow(hWnd);
		return(NULL);
	}

#ifndef	_WIN32_WCE
	{
		DWORD style = GetWindowLong(hWndBar, GWL_STYLE);
		style &= ~WS_CLIPCHILDREN;
		SetWindowLong(hWndBar, GWL_STYLE, style);
	}
#endif

	return(hWndBar);
}


// Pre-declaration of the function contained in this code module :
ATOM				MyRegisterClass	(HINSTANCE, LPTSTR);
BOOL				InitInstance	(HINSTANCE, int);
LRESULT CALLBACK	WndProc			(HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
#ifdef	_WIN32_WCE
					LPTSTR    lpCmdLine,
#else
					LPSTR     lpCmdLine,
#endif
					int       nCmdShow)
{
	MSG msg;
	HACCEL hAccelTable;

	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_CASIO, szWindowClass, MAX_LOADSTRING);

	// Application is initialized.   :
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_CASIO);

	// Main Message Loop :
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return msg.wParam;
}


//
//  MyRegisterClass()
//
//  Registration of a window class
//
//  comment :
//
//    It is important to call this function so that application can acquire 
//    the small icon related with application.
//
ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
	WNDCLASS	wc;

    wc.style			= CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc		= (WNDPROC) WndProc;
    wc.cbClsExtra		= 0;
    wc.cbWndExtra		= 0;
    wc.hInstance		= hInstance;
    wc.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_CASIO));
#ifdef	_WIN32_WCE
    wc.hCursor			= 0;
#else
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);
#endif
    wc.hbrBackground	= (HBRUSH) GetStockObject(WHITE_BRUSH);
#ifdef	_WIN32_WCE
    wc.lpszMenuName		= 0;
#else
	wc.lpszMenuName		= 0;
#endif
    wc.lpszClassName	= szWindowClass;

	return RegisterClass(&wc);
}


//
//  InitInstance(HANDLE, int)
//
//  Preservation of an instance handle, and creation of a main window
//
//  Comment : 
//    An instance handle is saved at a global variable, and the main window 
//    of a program is created and expressed as this function.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	HWND	hWnd;
#ifdef	_WIN32_WCE
	DWORD	dwStyle = WS_VISIBLE;
#else
	DWORD	dwStyle = WS_OVERLAPPEDWINDOW;
#endif

	hInst = hInstance;		// An instance handle is saved at a global variable.
	MyRegisterClass(hInstance, szWindowClass);

	hWnd = CreateWindow(szWindowClass, szTitle, dwStyle,
	CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);
// Change	CW_USEDEFAULT, CW_USEDEFAULT, 240, 320, NULL, NULL, hInstance, NULL);
	if (!hWnd)
	{	
		return FALSE;
	}

	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

	return TRUE;
}


//
//  WndProc(HWND, unsigned, WORD, LONG)
//
//  The message of a main window is processed.
//
//  WM_COMMAND	- Processing of an application menu
//  WM_PAINT	- Drawing of a main window
//  WM_DESTROY	- A notice and return of an end message
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static HWND hWndCSOBar = NULL;				// CSOBar's window handle

	switch (message) 
	{
		case WM_COMMAND:
		{
			int wmId    = LOWORD(wParam); 
			int wmEvent = HIWORD(wParam); 
			switch (wmId)
			{
				case CSOBAR_ADORNMENTID_CLOSE:
				{
#ifdef	_WIN32_WCE
					HCURSOR	hCursor= SetCursor(LoadCursor(NULL, IDC_WAIT));	// Sandglass
					CGDFlushRegistry();										// Save registry
					SetCursor(hCursor);										// End Sandglass
					CoshMainMenuExec(hWnd);									// start Menu
#endif
					DestroyWindow(hWnd);
					return(0);
				}

				case CSOBAR_ADORNMENTID_HELP:
				{
#ifdef	_WIN32_WCE
					TCHAR fileName[MAX_PATH + 1] = _T("");
					DWORD fineNameSize;
					fineNameSize = GetModuleFileName(NULL, fileName, MAX_PATH);
					if (fineNameSize){
						FilenameCutFileName(fileName);
						TCHAR temp[MAX_PATH + 3] = _T("");
						_stprintf(temp, _T("\"%scasio.html\""), fileName);
						PROCESS_INFORMATION	pi;
						memset(&pi, 0, sizeof(PROCESS_INFORMATION));
						CreateProcess(_T("PegHelp.exe"), temp, NULL, NULL, FALSE, 0, NULL, NULL, NULL, &pi);
					}
#endif
					return(0);
				}




				case ID_LEFT_ARROW:
				{
					TCHAR	temp[1024] = _T("");
#ifdef	_WIN32_WCE
					TCHAR driveName[MAX_PATH];
					int driveSize;
					WIN32_FIND_DATA findData;
					driveSize = GetSystemDisk(driveName, MAX_PATH);
					HANDLE find = FindFirstFlashCard(&findData);
					FindClose(find);
					_stprintf(temp, _T("%s, %s"), driveName, findData.cFileName);
					MessageBuzzer(MB_OK);
#endif
					MessageBox(hWnd, temp, _T("Information"), MB_OK);
					return(0);
				}

				default:
					return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		}

		case WM_CREATE:
		{
			if ((hWndCSOBar = casioCSOBar(hWnd, hInst)) == NULL){
				DestroyWindow(hWnd);
				return(0);
			}
			return(0);
		}

#ifdef	_WIN32_WCE
		case COSH_EXECUTEAPP:
		{
			SetForegroundWindow(hWnd);
			return(0);
		}
#endif

		case WM_PAINT:
		{
			PAINTSTRUCT	ps;
			BeginPaint(hWnd,&ps);
			EndPaint(hWnd,&ps);
			return(0);
		}

		case WM_DESTROY:
		{
			if (hWndCSOBar){
				CSOBar_Destroy(hWndCSOBar);
				hWndCSOBar = NULL;
			}
			PostQuitMessage(0);
			return(0);
		}

		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }

	return(0);
}
